Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-1.6-compat
%define eclipse_base     %{_libdir}/eclipse
%define gcj_support 0

Name:      eclipse-phpeclipse
Version:   1.2.1
Release:   alt1_2jpp6
Summary:   PHP Eclipse plugin
Group:     Development/Java
License:   CPL
URL:       http://phpeclipse.net/

# source tarball and the script used to generate it from upstream's source control
# script usage:
# $ sh get-phpeclipse.sh
Source0:   phpeclipse-%{version}.tar.gz
Source1:   get-phpeclipse.sh

Patch0:    %{name}-broken-help-links.patch
Patch1:    %{name}-fix-build-props.patch
Patch2:    %{name}-httpd-integration.patch
Patch3:    %{name}-no-htmlparser.patch
Patch4:    %{name}-rm-win32-help.patch
Patch5:    %{name}-external-parser.patch
Patch6:    %{name}-external-preview.patch


%if %{gcj_support}
BuildRequires: gcc-java
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%else
BuildArch:        noarch
%endif
BuildRequires: jpackage-utils
BuildRequires: eclipse-pde >= 3.4
Requires: jpackage-utils
Requires: eclipse-platform >= 3.4
Requires: php5
Requires: php5-xdebug
Requires: apache2

%description
PHPEclipse is an open source PHP IDE based on the Eclipse platform. Features
supported include syntax highlighting, content assist, PHP manual integration,
templates and support for the XDebug and DBG debuggers.

%prep
%setup -q -n phpeclipse-%{version}

# apply patches
%patch0 -p4
%patch1 -p4
%patch2 -p4
%patch3 -p4
%patch4 -p4
%patch5 -p4
%patch6 -p4

# ditch bundled libs in favor of building against fedora packaged libs
#rm net.sourceforge.phpeclipse.phpmanual.htmlparser/sax2.jar \
#   net.sourceforge.phpeclipse.phpmanual.htmlparser/htmllexer.jar \
#   net.sourceforge.phpeclipse.phpmanual.htmlparser/filterbuilder.jar \
#   net.sourceforge.phpeclipse.phpmanual.htmlparser/thumbelina.jar \
#   net.sourceforge.phpeclipse.phpmanual.htmlparser/junit.jar \
#   net.sourceforge.phpeclipse.phpmanual.htmlparser/htmlparser.jar
#build-jar-repository -s -p net.sourceforge.phpeclipse.phpmanual.htmlparser xml-commons-apis

#grep -lR sax2 * | xargs sed --in-place "s/sax2/xml-commons-apis/"

# fix jar versions
find -name MANIFEST.MF | xargs sed --in-place "s/0.0.0/%{version}/"

# make sure upstream hasn't sneaked in any jars we don't know about
JARS=""
for j in `find -name "*.jar"`; do
  if [ ! -L $j ]; then
    JARS="$JARS $j"
  fi
done
if [ ! -z "$JARS" ]; then
   echo "These jars should be deleted and symlinked to system jars: $JARS"
   exit 1
fi
(?-xism:%__subst s,/usr/sbin/httpd,/usr/sbin/httpd2, net.sourceforge.phpeclipse.externaltools/prefs/default_linux.properties)

%build
# build the main feature
%{eclipse_base}/buildscripts/pdebuild -f net.sourceforge.phpeclipse.feature

# build the debug features
%{eclipse_base}/buildscripts/pdebuild -f net.sourceforge.phpeclipse.debug.feature
%{eclipse_base}/buildscripts/pdebuild -f net.sourceforge.phpeclipse.xdebug.feature

%install
installDir=%{buildroot}%{_datadir}/eclipse/dropins/phpeclipse
debugInstallDir=%{buildroot}%{_datadir}/eclipse/dropins/phpeclipse-debug
xdebugInstallDir=%{buildroot}%{_datadir}/eclipse/dropins/phpeclipse-xdebug
install -d -m 755 $installDir
install -d -m 755 $debugInstallDir
install -d -m 755 $xdebugInstallDir
unzip -q -d $installDir build/rpmBuild/net.sourceforge.phpeclipse.feature.zip
unzip -q -d $debugInstallDir build/rpmBuild/net.sourceforge.phpeclipse.debug.feature.zip
unzip -q -d $xdebugInstallDir build/rpmBuild/net.sourceforge.phpeclipse.xdebug.feature.zip

# need to recreate the symlinks to libraries that were setup in "prep"
# because for some reason the ant copy task doesn't preserve them
#pushd $installDir/eclipse/plugins/net.sourceforge.phpeclipse.phpmanual.htmlparser_*
#rm *.jar
#build-jar-repository -s -p . xml-commons-apis
#popd

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%files
%doc net.sourceforge.phpeclipse.feature/cpl-v10.html
%{_datadir}/eclipse/dropins/phpeclipse
%{_datadir}/eclipse/dropins/phpeclipse-debug
%{_datadir}/eclipse/dropins/phpeclipse-xdebug

%if %{gcj_support}
%{_libdir}/gcj/%{name}
%endif

%changelog
* Mon Jan 12 2009 Igor Vlasenko <viy@altlinux.ru> 1.2.1-alt1_2jpp6
- new release (eclipse >=3.4)

* Fri Jan 02 2009 Igor Vlasenko <viy@altlinux.ru> 1.2.0-alt2_0.4.svn1573jpp6
- new version

* Wed Jul 30 2008 Igor Vlasenko <viy@altlinux.ru> 1.2.0-alt2_0.2.svn1573jpp6
- fixed dependency

* Mon Jul 28 2008 Igor Vlasenko <viy@altlinux.ru> 1.2.0-alt1_0.2.svn1573jpp6
- eclipse 3.3.2

* Tue Dec 11 2007 Igor Vlasenko <viy@altlinux.ru> 1.1.8-alt2_17jpp5.0
- fixed dependencies

* Tue Dec 04 2007 Igor Vlasenko <viy@altlinux.ru> 1.1.8-alt1_17jpp5.0
- converted from JPackage by jppimport script

